'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _plurallIcons = require('plurall-icons');

var _style3 = require('./style');

var _style4 = _interopRequireDefault(_style3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      focus: false
    }, _this.onFocus = function () {
      return _this.setState({ focus: true });
    }, _this.onBlur = function () {
      return _this.setState({ focus: false });
    }, _this.handleChange = function (option) {
      if (_this.props.onChange) {
        _this.props.onChange(option.value);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dropdown, [{
    key: 'renderOption',
    value: function renderOption(option) {
      var _this2 = this;

      var isSelected = option.value === this.props.selected;
      var classNames = (0, _classnames2.default)('option', { selected: isSelected });

      return _react2.default.createElement(
        'li',
        {
          key: option.value,
          role: 'presentation',

          onMouseDown: function onMouseDown() {
            return _this2.handleChange(option);
          },
          className: 'jsx-' + _style3.option.__scopedHash + ' ' + (classNames || '')
        },
        option.label,
        _react2.default.createElement(_style2.default, {
          styleId: _style3.option.__scopedHash,
          css: _style3.option.__scoped
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          options = _props.options,
          selected = _props.selected;

      var selectedOption = options.find(function (option) {
        return option.value === selected;
      });
      var value = selectedOption ? selectedOption.label : options[0].label;
      var className = (0, _classnames2.default)('dropdown', { focus: this.state.focus });

      return _react2.default.createElement(
        'div',
        {
          className: 'jsx-' + _style4.default.__scopedHash + ' ' + (className || '')
        },
        _react2.default.createElement('input', {
          value: value,
          readOnly: true,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          className: 'jsx-' + _style4.default.__scopedHash + ' ' + 'input'
        }),
        _react2.default.createElement(
          'div',
          {
            className: 'jsx-' + _style4.default.__scopedHash + ' ' + 'arrowIcon'
          },
          _react2.default.createElement(_plurallIcons.PureArrow, { size: 12 })
        ),
        _react2.default.createElement(
          'div',
          {
            className: 'jsx-' + _style4.default.__scopedHash + ' ' + 'optionsWrapper'
          },
          _react2.default.createElement(
            'ul',
            {
              className: 'jsx-' + _style4.default.__scopedHash + ' ' + 'options'
            },
            options.map(function (option) {
              return _this3.renderOption(option);
            })
          )
        ),
        _react2.default.createElement(_style2.default, {
          styleId: _style4.default.__scopedHash,
          css: _style4.default.__scoped
        })
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    label: _propTypes2.default.string
  })).isRequired,
  selected: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  onChange: _propTypes2.default.func
};

Dropdown.defaultProps = {
  selected: null
};

exports.default = Dropdown;